tam	EQU	4		; nmero de elementos de 16 bits na tabela (>=0)
chave	EQU	89ABH		; valor a procurar na tabela
pilha	EQU	2000H		; valor inicial do SP

PLACE	1000H			; localiza bloco de dados
base:	word	0123H		; 1 elemento da tabela
	word	4567H		; 2 elemento da tabela
	word	89ABH		; 3 elemento da tabela
	word	0CDEFH	; 4 elemento da tabela

PLACE	0000H			; localiza bloco de instrues
incio:	MOV	SP, pilha	; inicializa SP
	MOV	R1, base	; 1 parmetro (base da tabela) 
	MOV	R2, tam		; 2 parmetro (nmero de elementos da tabela)
	MOV	R3, chave	; 3 parmetro (valor a procurar)
	CALL	ProcuraPalavra	; procura valor. Resultado em R4
fim:	JMP	fim		; fim do programa

;*******************************************************************************
; ProcuraPalavra  Procura um elemento de 16 bits numa tabela, comeando pelo
; 			primeiro elemento da tabela
; Entradas  R1  endereo do 1 elemento da tabela (base). Tem de ser par.
;            R2  nmero de elementos de 16 bits na tabela (>=0)
;            R3  chave (valor de 16 bits a procurar)
; Sadas  R4  ndice do primeiro elemento que encontrar igual  chave
;               (-1 se no encontrar)
;*******************************************************************************
ProcuraPalavra:
	PUSH	R0		; salva registo
	MOV	R4, 0		; inicializa ndice de procura na tabela
maisUm:	CMP	R4, R2		; j chegou ao fim?
	JZ	noH		; termina sem ter achado o elemento
	MOV	R0, R4		; copia ndice para no o destruir
	ADD	R0, R0		; duplica ndice porque os endereos so em bytes
	MOV	R0, [R1 + R0]	; l um elemento da tabela (no endereo R1+R0)
	CMP	R0, R3		; este elemento  a chave procurada?
	JZ	acaba		; termina, j achou o elemento no ndice dado por R4
	ADD	R4, 1		; ndice do elemento seguinte
	JMP	maisUm		; ainda no achou, passa ao elemento seguinte
noH:	MOV	R4, -1		; indica que no achou 
acaba:	POP	R0		; repe registo
	RET 
