tam		EQU	8			; nmero de elementos de 8 bits na tabela (>=0)
chave		EQU	0ABH			; valor a procurar na tabela
pilha		EQU	2000H			; valor inicial do SP

PLACE		1000H						; localiza bloco de dados
base:		STRING	01H, 23H, 45H, 67H, 89H, 0ABH, 0CDH, 0EFH	 ; elementos da 
										; tabela

PLACE		0000H				; localiza bloco de instrues
incio:	MOV	SP, pilha		; inicializa SP
		MOV	R1, base		; 1. parmetro (base da tabela) 
		MOV	R2, tam		; 2. parmetro (nmero de elementos da tabela)
		MOV	R3, chave		; 3. parmetro (valor a procurar)
		CALL	ProcuraByte		; procura valor. Resultado em R4
fim:		JMP	fim			; fim do programa

;*******************************************************************************
; ProcuraByte  Procura um elemento de 8 bits numa tabela, comeando pelo
; primeiro elemento da tabela
; Entradas  	R1  endereo do 1. elemento da tabela (base). Pode ser mpar.
; 			R2  nmero de elementos de 8 bits na tabela (>=0)
; 			R3  chave (valor de 8 bits a procurar)
; Sadas  	R4  ndice do primeiro elemento que encontrar igual  chave
; 					  (-1 se no encontrar)
;*******************************************************************************
ProcuraByte:
		PUSH	R0			; guarda registo
		PUSH	R1			; guarda registo (para no alterar o parmetro R1)
		MOV	R4, 0			; inicializa ndice de procura na tabela
maisUm:	CMP	R4, R2		; j chegou ao fim?
		JZ	noH			; termina sem ter achado o elemento
		MOVB	R0, [R1]		; l um elemento da tabela
		CMP	R0, R3		; este elemento  a chave procurada?
		JZ	acaba			; termina, j achou o elemento no ndice dado por R4
		ADD	R1, 1			; endereo do elemento (byte) seguinte
		ADD	R4, 1			; ndice do elemento (byte) seguinte
		JMP	maisUm		; ainda no achou, passa ao elemento seguinte
noH:	MOV	R4, -1		; indica que no achou 
acaba: 	POP	R1			; repe registo
		POP	R0			; repe registo
		RET